.386
.model flat, stdcall
option casemap :none 

include BrainFckw.inc
include ValidateSyntax.asm

.code
start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
    invoke LoadLibrary,addr RichEdDLL
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke FreeLibrary,addr RichEdDLL
	
	invoke ExitProcess,0

DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL wSwd  	   :DWORD
LOCAL wSht		   :DWORD
LOCAL lwidth       :DWORD
LOCAL lheight	   :DWORD
LOCAL rc		   :RECT
LOCAL fBuffer[256] :BYTE
LOCAL edStream	   :EDITSTREAM
LOCAL crange	   :CHARRANGE
LOCAL msg		   :MSG
LOCAL RichLen2	   :DWORD
LOCAL ThreadID	   :DWORD

	.IF uMsg==WM_INITDIALOG
		invoke LoadIcon,hInstance,IDI_MAINICON
		invoke SendMessage,hWnd,WM_SETICON,ICON_SMALL,eax
		invoke GetCurrentDirectory,620,addr CompilerLocation
		invoke lstrcat,addr CompilerLocation,chr$("\")
		invoke lstrcat,addr CompilerLocation,addr CompilerExe
		
		;---------------------------------------------------------------
		; Set our hot keys
		invoke RegisterHotKey,hWnd,0001h,MOD_CONTROL,VK_N
		invoke RegisterHotKey,hWnd,0002h,MOD_CONTROL,VK_O
		invoke RegisterHotKey,hWnd,0003h,MOD_CONTROL,VK_S
		invoke RegisterHotKey,hWnd,0004h,MOD_ALT,VK_X
		invoke RegisterHotKey,hWnd,0005h,MOD_CONTROL,VK_Y
		invoke RegisterHotKey,hWnd,0006h,0,VK_F5
		invoke RegisterHotKey,hWnd,0007h,0,VK_F6
		invoke RegisterHotKey,hWnd,0008h,0,VK_F8
		
		;mov  hf.cbSize,sizeof hf
	    ;mov  hf.dwMask,CFM_BOLD+CFM_COLOR+CFM_FACE
	    ;mov  hf.dwEffects,CFE_BOLD
	
		;invoke CreateThread,NULL,0,addr HighlightChar,hWnd,NULL,addr ThreadID
		
		;---------------------------------------------------------------
		; Set the characters to bold
		mov    cf.cbSize,sizeof cf
		mov	   cf.dwMask,CFM_BOLD+CFM_COLOR+CFM_FACE
		mov	   cf.dwEffects,CFE_BOLD
		mov	   cf.crTextColor,00000000h
		invoke SendDlgItemMessage,hWnd,CodeBox,EM_SETCHARFORMAT,SCF_ALL,addr cf
	.ELSEIF uMsg==WM_SIZE
		invoke GetDlgItem,hWnd,CodeBox
		mov    rHandle,eax
		invoke GetDlgItem,hWnd,StatusBar
		mov    sHandle,eax
		
		;---------------------------------------------------------------
		; Get resize information
		invoke MoveWindow,sHandle,0,0,0,0,TRUE
		invoke GetClientRect,hWnd,addr rc
		push   rc.right
		pop    wSwd
		
		push   rc.bottom
		pop    wSht
		sub    wSht,19
		
		invoke MoveWindow,rHandle,0,0,wSwd,wSht,TRUE
	.elseif uMsg==WM_COMMAND
	
		;-----------------------------------------------------------------
	    ; New File
	    ;-----------------------------------------------------------------
	    .IF wParam==IDM_NEW
	    	.IF modified == 1
	    		invoke MessageBoxEx,hWnd,addr modifiedMsg,addr modifiedTitle,MB_YESNO,NULL
	    	   .IF    eax == IDNO
	    	   		  ; User just wants to clear the text box without saving
	    	   		  invoke GetDlgItem,hWnd,CodeBox
	    	   	      invoke SetWindowText,eax,0
	    	   	      mov    modified,0
	    	          mov    saveas,0
	    	   	      invoke SetDlgItemText,hWnd,StatusBar,addr Untitled
	    	   	      invoke RtlZeroMemory,addr szFileName,256
	    	   .ELSE
	    	          ; They want to save there file
	    	          invoke SendMessage,hWnd,WM_COMMAND,IDM_SAVE,0
	    	          mov    modified,0
	    	          mov    saveas,1
	    	   .ENDIF
	    	.ELSE
	    	   invoke GetDlgItem,hWnd,CodeBox
	    	   invoke SetWindowText,eax,0
	    	   mov    modified,0
	    	   mov    saveas,0
	    	   invoke SetDlgItemText,hWnd,StatusBar,addr Untitled
	    	   invoke RtlZeroMemory,addr szFileName,256
	    	.ENDIF
	    .ENDIF
	    
	    ;-----------------------------------------------------------------
	    ; Open a File
	    ;-----------------------------------------------------------------
	    .IF wParam==IDM_OPEN
		   ;--------------------------------------------------------------
		   ; Open a file and stream in to richedit
		   invoke RtlZeroMemory,addr ofn,sizeof ofn
		   mov	  ofn.lStructSize,sizeof ofn
		   push	  hWnd
		   pop	  ofn.hwndOwner
		   push   hInstance
		   pop	  ofn.hInstance
		   mov    ofn.lpstrFilter,offset ofnFilter
		   mov    ofn.lpstrFile,offset szFileName
		   mov    ofn.lpstrFileTitle,offset szFileTitle
		   mov    ofn.nMaxFile,256
		   mov    ofn.Flags,OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_PATHMUSTEXIST or OFN_NOVALIDATE
		   invoke GetOpenFileName,addr ofn
		   .IF	  eax != 0
		   		  invoke GetFileTitle,addr szFileName,addr fBuffer,sizeof fBuffer
		   	      invoke SetDlgItemText,hWnd,StatusBar,addr fBuffer
		   	      
		   	      ;--------------------------------------------------------
		   	      ; Now we stream in the file
		   	      invoke CreateFile,addr szFileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
		   	      .IF    eax != INVALID_HANDLE_VALUE
		   	      		 mov rFile,eax
		   	      		 mov edStream.dwCookie,eax
		   	      		 mov edStream.pfnCallback,offset StreamInProc
		   	      		 invoke SendDlgItemMessage,hWnd,CodeBox,EM_STREAMIN,SF_TEXT,addr edStream
		   	      		 invoke CloseHandle,rFile
		   	      		 mov    modified,1
		   	      		 mov    saveas,1
		   	      .ELSE
		   	             invoke SetDlgItemText,hWnd,StatusBar,chr$("Error opening file...")
		   	      .ENDIF
		   .ENDIF
		.ENDIF
	    
	    ;-----------------------------------------------------------------
	    ; Save a file
	    ;-----------------------------------------------------------------
	    .IF wParam==IDM_SAVE
	    
	        .IF saveas == 1
	    	    invoke CreateFile,addr szFileName,GENERIC_WRITE,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	    	    .IF    eax != INVALID_HANDLE_VALUE
	    		       mov sFile,eax
	    		       mov edStream.dwCookie,eax
	    		       mov edStream.pfnCallback,offset StreamOutProc
	    		       invoke SendDlgItemMessage,hWnd,CodeBox,EM_STREAMOUT,SF_TEXT,addr edStream
	    		       invoke CloseHandle,sFile
	    		       mov    modified,0
	    		       invoke SetDlgItemText,hWnd,StatusBar,addr SuccessSaved
	    		       invoke Sleep,300
	    		       invoke GetFileTitle,addr szFileName,addr fBuffer,sizeof fBuffer
	    		       invoke SetDlgItemText,hWnd,StatusBar,addr fBuffer
	    	    .ELSE
	    	           mov saveas,0
	    	    .ENDIF
	    	
	    	.ELSEIF saveas == 0
	    	    invoke RtlZeroMemory,addr sfn,sizeof sfn
	    	 
	    	    mov	   sfn.lStructSize,sizeof sfn
		   		push   hWnd
		   		pop	   sfn.hwndOwner
		   		push   hInstance
		   		pop	   sfn.hInstance
		   		mov    sfn.lpstrFilter,offset ofnFilter
		   		mov    sfn.lpstrFile,offset szFileName
		   		mov    sfn.lpstrFileTitle,offset szFileTitle
		   		mov    sfn.nMaxFile,256
		   		mov    sfn.Flags,OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_PATHMUSTEXIST or OFN_NOVALIDATE
		   		invoke GetOpenFileName,addr sfn
		   		.IF    eax != 0
		   		invoke CreateFile,addr szFileName,GENERIC_WRITE,
		   		                  FILE_SHARE_READ+FILE_SHARE_WRITE,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
		   		                  
		   		.IF    eax != INVALID_HANDLE_VALUE
		   			   mov sFile,eax
	    		       mov edStream.dwCookie,eax
	    		       mov edStream.pfnCallback,offset StreamOutProc
	    		       invoke SendDlgItemMessage,hWnd,CodeBox,EM_STREAMOUT,SF_TEXT,addr edStream
	    		       invoke CloseHandle,sFile
	    		       mov	  modified,0
	    		       mov    saveas,1
	    		       invoke SetDlgItemText,hWnd,StatusBar,addr SuccessSaved
	    		       invoke Sleep,300
	    		       invoke GetFileTitle,addr szFileName,addr fBuffer,sizeof fBuffer
	    		       invoke SetDlgItemText,hWnd,StatusBar,addr fBuffer
		   		.ELSE
		   		       mov    saveas,0
		   		.ENDIF
		   		.ENDIF
		   	.ENDIF
	    .ENDIF
	
		;-------------------------------------------------------------
		; EDIT menu items
		;-------------------------------------------------------------
		.IF wParam==IDM_UNDO
			invoke SendDlgItemMessage,hWnd,CodeBox,EM_UNDO,0,0
		.ENDIF
		
		.IF wParam==IDM_REDO
			invoke SendDlgItemMessage,hWnd,CodeBox,EM_REDO,0,0
		.ENDIF
		
		.IF wParam==IDM_CUT
			invoke SendDlgItemMessage,hWnd,CodeBox,WM_CUT,0,0
		.ENDIF
		
		.IF wParam==IDM_COPY
			invoke SendDlgItemMessage,hWnd,CodeBox,WM_COPY,0,0
		.ENDIF
		
		.IF wParam==IDM_PASTE
			invoke SendDlgItemMessage,hWnd,CodeBox,WM_PASTE,0,0
		.ENDIF
		
		.IF wParam==IDM_DELETE
			invoke SendDlgItemMessage,hWnd,CodeBox,EM_REPLACESEL,TRUE,0
		.ENDIF
		
		.IF wParam==IDM_SELECTALL
		    mov    crange.cpMin,0
		    mov    crange.cpMax,-1
			invoke SendDlgItemMessage,hWnd,CodeBox,EM_EXSETSEL,0,addr crange
		.ENDIF
		
		.IF wParam==IDM_FORECOLOR
			invoke ColorDialog,hWnd,hInstance,0
			mov    cf.crTextColor,eax
			
			invoke SendDlgItemMessage,hWnd,CodeBox,EM_SETCHARFORMAT,SCF_ALL,addr cf
		.ENDIF
		
		.IF wParam==IDM_BACKCOLOR
			invoke ColorDialog,hWnd,hInstance,0
			invoke SendDlgItemMessage,hWnd,CodeBox,EM_SETBKGNDCOLOR,0,eax
		.ENDIF
		
		.IF wParam==IDM_RUN
			invoke RtlZeroMemory,addr CompilerBuffer,620
			invoke lstrcat,addr CompilerBuffer,chr$("/f ")
			invoke lstrcat,addr CompilerBuffer,addr szFileName
			invoke lstrcat,addr CompilerBuffer,chr$(" /p")
			
			invoke ShellExecute,hWnd,0,addr CompilerLocation,addr CompilerBuffer,0,SW_SHOWDEFAULT
		.ENDIF
		
		.IF wParam==IDM_SYNTAX
			invoke GetDlgItem,hWnd,CodeBox
			invoke SendMessage,eax,WM_GETTEXT,30000,addr ValidateBuffer
			invoke StrLen,addr ValidateBuffer
			invoke ValidateSyntax,addr ValidateBuffer,eax
		.ENDIF
		
		.IF wParam==IDM_NEWWINDOW
			invoke WinExec,chr$("BrainFckw.exe"),SW_SHOW
		.ENDIF
		
		.IF wParam==IDM_MINIMIZE
			invoke ShowWindow,hWnd,SW_MINIMIZE
		.ENDIF
		
		.IF wParam==IDM_MAXIMIZE
			invoke ShowWindow,hWnd,SW_MAXIMIZE
		.ENDIF
		
		.IF wParam==IDM_EXIT
			invoke SendMessage,hWnd,WM_CLOSE,0,0
		.endif
		
		.IF wParam==IDM_ABOUT
			invoke EnableWindow,hWnd,FALSE
			push   hWnd
			pop    WindowHandle
			invoke DialogBoxParam,hInstance,AboutDialog,NULL,addr AboutProc,NULL
		.ENDIF
		
	;-------------------------------------------------------------
	; Hot Key Handling
 	.ELSEIF uMsg==WM_HOTKEY
 	
 		invoke GetActiveWindow
 		
 		; Create new window
 		.IF wParam==0001h
 			.IF    eax==hWnd
 				   invoke SendMessage,hWnd,WM_COMMAND,IDM_NEW,0
 			.ENDIF
 		.ENDIF
 		
 		; Open a file
 		.IF wParam==0002h
 			.IF	   eax==hWnd
 				   invoke SendMessage,hWnd,WM_COMMAND,IDM_OPEN,0
 			.ENDIF
 		.ENDIF
 		
 		; Save a file
 		.IF wParam==0003h
 			.IF	   eax==hWnd
 				   invoke SendMessage,hWnd,WM_COMMAND,IDM_SAVE,0
 			.ENDIF
 		.ENDIF
 		
		; Exit Program
		.IF wParam==0004h
			.IF    eax==hWnd
				   invoke SendMessage,hWnd,WM_CLOSE,0,0
			.ENDIF
		.ENDIF
		
		; Redo
		.IF wParam==0005h
			.IF    eax==hWnd
				   invoke SendMessage,hWnd,WM_COMMAND,IDM_REDO,0
			.ENDIF
		.ENDIF
		
		; Run File
		.IF wParam==0006h
			.IF    eax==hWnd
				   invoke SendMessage,hWnd,WM_COMMAND,IDM_RUN,0
			.ENDIF
		.ENDIF
		
		; Check syntax
		.IF wParam==0007h
			.IF    eax==hWnd
				   invoke SendMessage,hWnd,WM_COMMAND,IDM_SYNTAX,0
			.ENDIF
		.ENDIF
		
		; Create a window
		.IF wParam==0008h
			.IF    eax==hWnd
				   invoke SendMessage,hWnd,WM_COMMAND,IDM_NEWWINDOW,0
			.ENDIF
		.ENDIF
		
	;-----------------------------------------------------------------
	; Close the program
	;-----------------------------------------------------------------
	.ELSEIF uMsg==WM_CLOSE
	    .IF    modified == 1
	    	   invoke MessageBoxEx,hWnd,addr modifiedMsg,addr modifiedTitle,MB_YESNO,NULL
	    	   .IF    eax == IDNO
	    	   	      invoke EndDialog,hWnd,0
	    	   .ELSEIF eax == IDYES
	    	          invoke SendMessage,hWnd,WM_COMMAND,IDM_SAVE,0
	    	   .ENDIF
	    .ELSE
	           invoke EndDialog,hWnd,0
	    .ENDIF
	.ELSE
		mov		eax,FALSE
		ret
	.ENDIF
	mov		eax,TRUE
	ret

DlgProc endp

;--------------------------------------------------------------------------
; Stream in Procedure for Rich Edit
;--------------------------------------------------------------------------
StreamInProc proc readFile:DWORD,rBuffer:DWORD, nBytes:DWORD, nBytesRead:DWORD
	invoke ReadFile,readFile,rBuffer,nBytes,nBytesRead,0
	xor eax,1
	ret
StreamInProc endp

;--------------------------------------------------------------------------
; Stream out Procedure for Rich Edit
;--------------------------------------------------------------------------
StreamOutProc proc readFile:DWORD,rBuffer:DWORD, nBytes:DWORD, nBytesWritten:DWORD
	invoke WriteFile,readFile,rBuffer,nBytes,nBytesWritten,0
	xor eax,1
	ret
StreamOutProc endp

;----------------------------------------------------------------------------
; About Procedure
;----------------------------------------------------------------------------
AboutProc proc aWnd:HWND,aMsg:UINT,aParam:WPARAM,alParam:LPARAM

	.IF aMsg==WM_CLOSE
		invoke EndDialog,aWnd,0
	.ELSEIF aMsg==WM_COMMAND
	
		.IF aParam==IDC_HOMEPAGE
		    invoke ShellExecute,aWnd,0,addr Website,0,0,SW_SHOWNORMAL
		.ENDIF
		
		.IF aParam==IDC_CLOSE
		    invoke EnableWindow,WindowHandle,TRUE
			invoke SendMessage,aWnd,WM_CLOSE,0,0
		.ENDIF
		
	.ELSEIF aMsg==WM_INITDIALOG
		invoke LoadIcon,hInstance,IDI_MAINICON
		invoke SendMessage,aWnd,WM_SETICON,ICON_SMALL,eax
	.ELSE
		mov		eax,FALSE
		ret
	.ENDIF
	mov		eax,TRUE
	ret
AboutProc endp
end start
