;----------------------------------------------------
; This code validates that the text in our richedit
; is valid brainf*ck code. With Extended Syntax.
;----------------------------------------------------

.code
ValidateSyntax PROC bfBuffer:DWORD,bfLen:DWORD
LOCAL err:BYTE
LOCAL tmp[100]:BYTE

;----------------------------------------------------
; Move our buffer into ebx and 0 the counter for
; the string length and move our string length into
; esi.
;----------------------------------------------------
	mov    esi,bfLen									; Store our buffer length in esi
	xor    ecx,ecx										; clear the byte counter
    mov    err,0										; lets use know if we have an error
	mov    ebx,bfBuffer									; move our buffer into eax
;----------------------------------------------------
; Below are the Extended and regular BrainF*ck syntax
;----------------------------------------------------
val1:
    cmp    ecx,esi										; have we reached the end of our buffer?
    je     finished										; jump to finished
    cmp    byte ptr[ebx],'+'							; compare the byte to the + sign, increase byte at program counter
    je     next											; its valid so move to the next byte
    cmp    byte ptr[ebx],'-'							; compare the byte to the - sign, decrease byte at program counter
    je     next											; its valid so move to the next byte
    cmp    byte ptr[ebx],'>'							; compare the byte to the > sign, move program counter forward to the next cell
    je     next											; its valid so move to the next byte
    cmp    byte ptr[ebx],'<'							; compare the byte to the < sign, move program counter back to the last cell
    je     next											; its valid so move to the next byte
    cmp    byte ptr[ebx],'.'							; compare the byte to the . sign, print out the current byte
    je     next											; its valid so move to the next byte
    cmp    byte ptr[ebx],','							; compare the byte to the , sign, print out the current cell
    je     next											; its valid so move to the next byte
    cmp    byte ptr[ebx],'['							; compare the byte to the [ sign, open loop
    je     next											; its valid so move to the next byte
    cmp    byte ptr[ebx],']'							; compare the byte to the ] sign, close loop
    je     next											; its valid so move to the next byte
    cmp    byte ptr[ebx],'@'							; compare the byte to the @ sign, push current cell to the stack
    je     next											; its valid move to the next byte
    cmp    byte ptr[ebx],'&'							; compare the byte to the & sign, pop the last value off the stack
    je     next											; its valid move to the next byte
    cmp    byte ptr[ebx],'*'							; compare the byte to the * sign, zero current cell
    je     next											; its valid move to the next byte
;----------------------------------------------------
; Here we our checking that the include file is valid
;----------------------------------------------------
    cmp    byte ptr[ebx],'%'							; the % is for our include file
    jne    val14										; if its not % then compare the next instruction
    je     finde										; if its equal we need either a space or a "
finde:
    inc    ebx											; go to the next byte
    cmp    byte ptr[ebx],13								; did we reach end of line?
    je     next											; if yes go to the next byte
    cmp    byte ptr[ebx],'"'							; if we got a " then they included a file so lets just find the end of line
    je     findendl										; jump to findendl
    cmp    byte ptr[ebx],10								; line feed
    je     next											; move to next byte
    cmp    byte ptr[ebx],0								; nothing
    je     next											; move to next byte
    jne    finde										; keep looping until we find one of the above
findendl:
    inc    ebx											; increment to the next byte
    cmp    byte ptr[ebx],13								; we need a new line this is carriage return
    je     next											; we accept just a CR so go to next byte
    cmp    byte ptr[ebx],10								; this is line feed
    je     next											; go to next byte then
    cmp    byte ptr[ebx],0								; we also accept 0, nothing
    jne    findendl										; loop till we find one of the above
    
;----------------------------------------------------
; Check for end of lines because they are valid
;----------------------------------------------------
val14:
    cmp    byte ptr[ebx],13
    je     next
    cmp    byte ptr[ebx],10
    je     next
;----------------------------------------------------
; New line for brainf*ck is valid
;----------------------------------------------------
    cmp    byte ptr[ebx],'$'
    je     next
;----------------------------------------------------
; Spaces are valid
;----------------------------------------------------
    cmp    byte ptr[ebx],32
    je     next
;----------------------------------------------------
; Nothing is also valid
;----------------------------------------------------
    cmp    byte ptr[ebx],0
    je     next
;----------------------------------------------------
; Here we have to check to make sure that the comments
; are valid.
;----------------------------------------------------
    cmp    byte ptr[ebx],'#'
    je     valL
    jne    error
valL:
    inc    ebx
    cmp    byte ptr[ebx],13
    je     next
    cmp    byte ptr[ebx],10
    je     next
    cmp    byte ptr[ebx],0
    je     next
    cmp    byte ptr[ebx],32
    je     valL
    jne    valL
next:
    inc    ebx
    inc	   ecx
    jmp    val1
;----------------------------------------------------
; We stop on first error and print the character that
; is invalid.
;----------------------------------------------------
error:
	mov    al,byte ptr [ebx]
	push   eax
	push   offset InvalidSyntaxMsg
	push   offset ErrorBuffer
	call   wsprintf

	push   NULL
	push   MB_OK
	push   offset InvalidSyntax
	push   offset ErrorBuffer
	push   0
	call   MessageBoxEx 
    mov    err,1
	jmp    finished
;----------------------------------------------------
; jmp to the next character
;----------------------------------------------------
finished:
	cmp    err,0
	jne    doneerr
	
	push   NULL
	push   MB_OK
	push   offset ValidSyntax
	push   offset ValidSyntaxMsg
	push   0
	call   MessageBoxEx
doneerr:
	xor eax,eax
	ret
	
ValidateSyntax endp
